#include <qlayout.h>
#include <qlabel.h>
#include <qlineedit.h>
#include <dialset.h>
#include <dialsetedit.h>

DialKeyEdit::DialKeyEdit( int id, QGridLayout *grid, QWidget *parent, const char *name )
	: QWidget( parent, name )
{
	QLabel *rowid = new QLabel( QString( "%1" ).arg( id ), parent );
	grid->addWidget( rowid, id, 0 );

	keyname = new QLineEdit( parent );
	grid->addWidget( keyname, id, 1 );

	tone1 = new QLineEdit( parent );
	grid->addWidget( tone1, id, 2 );

	tone2 = new QLineEdit( parent );
	grid->addWidget( tone2, id, 3 );

	tone3 = new QLineEdit( parent );
	grid->addWidget( tone3, id, 4 );
}

DialKeyEdit::~DialKeyEdit()
{
}

DialSetEdit::DialSetEdit( QWidget *parent, const char *name )
	: QWidget( parent, name )
{
	QGridLayout *grid = new QGridLayout( this, 4, 4 );

	QLabel *rowtitle = new QLabel( "Id", this );
	rowtitle->setFrameStyle( QFrame::Panel | QFrame::Sunken );
	grid->addWidget( rowtitle, 0, 0 );

	rowtitle = new QLabel( "KeyName", this );
	rowtitle->setFrameStyle( QFrame::Panel | QFrame::Sunken );
	grid->addWidget( rowtitle, 0, 1 );

 	rowtitle = new QLabel( "Tone 1", this );
	rowtitle->setFrameStyle( QFrame::Panel | QFrame::Sunken );
	grid->addWidget( rowtitle, 0, 2 );

	rowtitle = new QLabel( "Tone 2", this );
	rowtitle->setFrameStyle( QFrame::Panel | QFrame::Sunken );
	grid->addWidget( rowtitle, 0, 3 );

	rowtitle = new QLabel( "Tone 3", this );
	rowtitle->setFrameStyle( QFrame::Panel | QFrame::Sunken );
	grid->addWidget( rowtitle, 0, 4 );

	for( int i = 1; i < 24; i++ ) {
		DialKeyEdit *curedit = new DialKeyEdit( i, grid, this );
		grid->addMultiCellWidget( curedit, i, i, 0, 4 );
		edits.insert( i, curedit );
	}

	resize( 300, 480 );
}

DialSetEdit::~DialSetEdit()
{
}

void DialSetEdit::setDialSet( DialSet *newset )
{
	editset = newset;
	if( newset != 0 ) {
		resync();
	}
}

void DialSetEdit::resync()
{
	// For now, we hardcode
	for( int i = 1; i < 24; i++ ) {
		if( ( edits[ i ] != 0 ) && ( editset->getKey( i ) != 0 ) ) {
			edits[ i ]->getKeyName()->setText( editset->getKey( i )->getName() );
			edits[ i ]->getTone1()->setText( QString( "%1" ).arg( editset->getKey( i )->getFreq( 0 ) ) );
			edits[ i ]->getTone2()->setText( QString( "%1" ).arg( editset->getKey( i )->getFreq( 1 ) ) );
			edits[ i ]->getTone3()->setText( QString( "%1" ).arg( editset->getKey( i )->getFreq( 2 ) ) );
		}
	}
}

