#ifndef KRADVIEW_H_INCLUDED
#define KRADVIEW_H_INCLUDED

#include <qwidget.h>

class DspOut;
class DspControl;
class DspAction;
class DialPad;
class DialSet;
class QLineEdit;
class QCheckBox;
class QLabel;

class KRadView : public QWidget
{
	Q_OBJECT
public:
	KRadView( QWidget *parent = 0, const char *name = 0 );
	~KRadView();

	DialSet *getDialSet();

public slots:
	void setDialSet( DialSet *newset );
	void doAction( DspAction *curaction );
	void dialNumber( QString number );

signals:
	void addToList( QString number );

private:
	DspOut *dspdev;
	DspControl *controller;
	DialPad *dialpad;
	QLineEdit *playline;
	QCheckBox *rec;
	QLabel *setname;

private slots:
	void doTick();
	void inputReturnPressed();
	void padKeyPressed( long id );
	void showKeysPressed();
	void showKeysReleased();
	void addToListClicked();
};

#endif // KRADVIEW_H_INCLUDED
